
<style>
.sex {
  height: calc(100% - 25px);
}
.statistics-title {
  font-size: 24px;
  color: #111;
  margin-bottom: 30px;
  font-family: perfectFont;
}
.sex .conten-box {
  display: flex;
  flex-direction: column;
  height: calc(100% - 62px);
}
.sex .conten-box .el-card .el-card__header {
  font-weight: normal !important;
}
.sex .conten-box .top {
  flex: 1.2;
  margin-bottom: 25px;
}
.sex .conten-box .bottom {
  flex: 0.8;
}
.sex .conten-box .left {
  height: 100%;
}
.sex .conten-box .el-card.blue {
  background: #409efe !important;
  color: #fff !important;
  height: calc(100% - 2px);
}
.sex .conten-box .el-card .el-card__body {
  padding: 20px;
  height: calc(100% - 98px);
  max-height: calc(100% - 98px);
}
.sex .conten-box .img {
  display: flex;
  align-items: flex-end;
  text-align: center;
  padding: 20px 70px 10px 70px !important;
  justify-content: space-between;
  font-size: 14px;
}
.sex .sjsm {
  display: flex;
  flex-direction: column;
}
.sex .sjsm > div:nth-child(1) {
  margin-bottom: 20px;
}
.sex .sjsm > div {
  flex: 1;
  background: rgba(244, 245, 249, 1);
  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: 20px;
}
.sex .sjsm > div .left {
  display: flex;
  align-items: center;
}
.sex .sjsm > div .left img {
  padding-right: 10px;
}
.sex .sjsm > div .right {
  text-align: right;
  color: #888888;
  font-size: 12px;
}
.sex .hight-font {
  color: #409efe !important;
  font-size: 14px;
}
</style>
<template>
  <div class="sex" v-loading="loading">
    <div class="statistics-title bold18">季节统计</div>
    <div class="conten-box" v-if="!loading">
      <el-row :gutter="25" class="top">
        <el-col :span="16" class="left">
          <el-card class="blue">
            <div slot="header" class="clearfix">
              <span>季节统计</span>
            </div>
            <el-row :gutter="80" style="height: 100%;">
              <el-col :span="10" class="img">
                <div>
                  <div style="margin-bottom: 10px;">
                    <img src="../../assets/img/tongji/jj.png" alt />
                  </div>
                  <p>季节</p>
                </div>
              </el-col>
              <el-col :span="14" style="height: 100%;">
                <sexChart :myData="chartData" :strArr="strArr" />
              </el-col>
            </el-row>
          </el-card>
        </el-col>
        <el-col :span="8" style="height: 100%;">
          <el-card style="height: calc(100% - 2px);">
            <div slot="header" class="clearfix">
              <span>
                购物统计
                <span class="font-size-12">（按平均计算）</span>
              </span>
            </div>
            <shopChart :shopChartData="shopChartData" />
          </el-card>
        </el-col>
      </el-row>
      <el-row :gutter="25" class="bottom">
        <el-col :span="16" style="height: 100%;">
          <el-card style="height: 100%;">
            <div slot="header" class="clearfix">
              <span>数据说明</span>
            </div>
            <div style="height: 100%;" class="sjsm">
              <div v-for="(item, index) in orders" :key="index">
                <div class="left">
                  <img v-if="item.SeasonType === 1" src="../../assets/img/tongji/cj.png" alt />
                  <img v-if="item.SeasonType === 2" src="../../assets/img/tongji/xj.png" alt />
                  <img v-if="item.SeasonType === 3" src="../../assets/img/tongji/qj.png" alt />
                  <img v-if="item.SeasonType === 4" src="../../assets/img/tongji/dj.png" alt />
                  <span class="font-size-12">{{item.SeasonTypeName}}</span>
                </div>
                <div class="right">
                  <p>
                    累计报名
                    <span class="hight-font">{{item.SeasonCount}}</span>人，报名均价为
                    <span class="hight-font">{{item.Unit_Price}}</span>元
                  </p>
                  <p>
                    最喜爱产品
                    <span class="hight-font">《{{item.LtName}}》</span>
                  </p>
                </div>
              </div>
            </div>
          </el-card>
        </el-col>
        <el-col :span="8" style="height: 100%;">
          <el-card style="height: 100%;">
            <div slot="header" class="clearfix">
              <el-row style="width:100%">
                <el-col :span="12" size="30">推荐解答</el-col>
              </el-row>
            </div>
            <div class="situ">
              <div class="c">{{topOne && topOne.Content ? topOne.Content : '暂无'}}</div>
              <div class="bot" @click="drawer = true">
                {{BbsList.length ? '查看更多，参与讨论('+ BbsList.length +')' : '暂时还没有讨论，快来发起讨论吧~'}}
                <i
                  class="el-icon-d-arrow-right"
                ></i>
              </div>
            </div>
          </el-card>
        </el-col>
      </el-row>
    </div>
    <el-drawer size="695px" :visible.sync="drawer" direction="rtl" :with-header="false">
      <discussBox :type="discussID" />
    </el-drawer>
  </div>
</template>
<script>
import sexChart from "./model/sexChart";
import shopChart from "./model/shopChart";
import discussBox from "./model/discussBox";
export default {
  components: {
    sexChart,
    shopChart,
    discussBox,
  },
  data() {
    return {
      discussID: 0,
      drawer: false,
      chartData: [0, 0],
      shopChartData: [],
      SexOrder: [],
      loading: false,
      strArr: ["春季", "夏季", "秋季", "冬季"],
      orders: [],
      discussID: 16,
      BbsList: [],
      topOne: {},
    };
  },
  watch: {},
  mounted() {
    this.GetSexOrderList();
    this.GetBbsListByType();
  },
  methods: {
    GetBbsListByType() {
      this.apipost(
        "/api/Customer/GetBbsListByType",
        { t: this.discussID },
        (res) => {
          this.BbsList = res.data.data;

          if (this.BbsList && this.BbsList.length > 0) {
            this.topOne = this.BbsList[0];
            this.BbsList.forEach((x) => {
              if (x.Likes > this.topOne.Likes) {
                this.topOne = x;
              }
            });
          }
        }
      );
    },
    GetSexOrderList() {
      this.loading = true;
      this.apipost("/api/Statistic/GetSeasonShopList", {}, (res) => {
        var seasonArray = res.data.data;
        let contShop = 0;
        let contNum = 0;
        let one = 0,
          two = 0,
          three = 0,
          four = 0;
        let oneN = 0,
          twoN = 0,
          threeN = 0,
          fourN = 0;
        if (seasonArray != null && seasonArray.length > 0) {
          seasonArray.forEach((item) => {
            contShop += Number(item.TotalMoney);
            contNum += Number(item.SeasonCount);
            switch (item.SeasonType) {
              case 1:
                one = item.TotalMoney;
                oneN = item.SeasonCount;
                break;
              case 2:
                two = item.TotalMoney;
                twoN = item.SeasonCount;
                break;
              case 3:
                three = item.TotalMoney;
                threeN = item.SeasonCount;
                break;
              case 4:
                four = item.TotalMoney;
                fourN = item.SeasonCount;
                break;
            }
          });
        }
        let chartData = [],
          shopChartData = [];

        chartData.push(((oneN / contNum) * 100).toFixed(2));
        chartData.push(((twoN / contNum) * 100).toFixed(2));
        chartData.push(((threeN / contNum) * 100).toFixed(2));
        chartData.push(((fourN / contNum) * 100).toFixed(2));
        shopChartData.push({
          num: Number(((one / contShop) * 100).toFixed(2)),
          color: "#409efe",
          text: "春季",
        });
        shopChartData.push({
          num: Number(((two / contShop) * 100).toFixed(2)),
          color: "#FFA475",
          text: "夏季",
        });
        shopChartData.push({
          num: Number(((three / contShop) * 100).toFixed(2)),
          color: "#99BD7B",
          text: "秋季",
        });
        shopChartData.push({
          num: Number(((four / contShop) * 100).toFixed(2)),
          color: "#D2C9F1",
          text: "冬季",
        });
        this.chartData = chartData;
        this.shopChartData = shopChartData;
        this.orders = res.data.data;
        this.getOrders();
      });
    },
    getOrders() {
      this.apipost("/api/Statistic/GetSeasonOrderList", {}, (res) => {
        res.data.data.forEach((x) => {
          this.orders.forEach((subItem) => {
            if (x.NewSeasonType == subItem.SeasonType) {
              subItem.LtName = x.LtName;
              subItem.Unit_Price = x.Unit_Price;
            }
          });
        });
        this.loading = false;
      });
    },
  },
};
</script>
